// Proving mutual exclusion

bool flag = 0;
bool in_cs[2];

active proctype Producer() {
  tryagain:
    flag == 0;
      in_cs[_pid] = 1; // Enter critical section
      // Write to buffer 
      in_cs[_pid] = 0; // Exit critical section
    flag = 1; 
  goto tryagain;
}

active proctype Consumer () {
  tryagain:
    flag == 1;
    in_cs[_pid] = 1; // Enter critical section
    assert(in_cs[1 - _pid] == 1); // Mutal exclusion
    // Read from buffer
    in_cs[_pid] = 0; // Exit critical section
    flag = 0;
  goto tryagain;
}


