/*
Dining smithosophers problem with 'polite dining' algorithm
Used d_step to shorten the runtime by not blowing up the number of states.
*/

#define NUM_SMITH 4 //This is also num_chopstick
#define left(p) p
#define right(p) (p + 1)%NUM_SMITH
#define NONE 0
#define LEFT 1
#define RIGHT 2
#define BOTH 3
#define CLEAN 0
#define DIRTY 1

bool chopState[NUM_SMITH];
byte smithState[NUM_SMITH];
bool requests[NUM_SMITH];

inline LeftOk(smith, res){
    // TODO: Fill in
    // Check whether it is possible for blacksmith 'smith' to take their left chopstick.
    // Store the bool value into res.

}

inline RightOk(smith, res){
    // TODO: Fill in
    // Check whether it is possible for blacksmith 'smith' to take their right chopstick.
    // Store the bool value into res.

}

inline DirtyOk(smith, res){
    // TODO: Fill in
    // Check whether it is possible for blacksmith 'smith' to drop their chopsticks.
    // Store the bool value into res.

}

inline RequestOk(chop, res){
	// TODO: Fill in
    // Check whether it is possible for chopstick 'chop' to be cleaned and change the owners.
    // Store the bool value into res.

}

inline RequestLeft(){
	d_step{
		
	    // Non-deterministically chooses a random blacksmith who can request their left chopstick. 
	    // Stores the results in smith.
	    byte smith = 255;
	    byte tmp = 0; 
	    bool ok = 0 ;  
	    do
	    :: tmp < (NUM_SMITH) ->
	    	ok = 0;
	    	LeftOk(tmp, ok);
	    	if
	    	:: ok -> smith = tmp;
	    	:: else -> skip;
	    	fi;
	    	tmp++;
	    :: smith != 255 -> break; 
	    od;
		printf("Blacksmith %d requested chopstick %d LEFT\n", smith, left(smith));
		// 	TODO: Complete the function.

    	// Update the states to reflect 'smith' requesting their left chopstick

	}
}

inline RequestRight(){
	d_step{
		// 	TODO: Complete the function.
		byte smith;
		// Non-deterministically chooses a random blacksmith who can request their left chopstick. 
	    // Stores the results in smith.


    	// Update the states to reflect 'smith' requesting their right chopstick

	}
}

inline DirtyChops(){
	d_step{
		// 	TODO: Complete the function.
		byte smith ;
		// Non-deterministically chooses a random blacksmith who use both of their chopsticks
		// (these chopsticks should be clean). 
	    // Stores the results in smith.


    	// Update the states to reflect 'smith' using their chopsticks to eat leaving them dirty

	}
}

inline HonorRequest(){
	d_step{
		// 	TODO: Complete the function.
		byte chop ;
		// Non-deterministically chooses a random 'chopstick' which is currently dirty. 
	    // Stores the results in chop.


		// Update the states to reflect a chopstick 'chop' being washed and transfered to another blacksmith.

	}
}

active proctype main(){
	int i; 
	// TODO: Configure the initial states of the blacksmiths and chopstick.


	////////////////////////////////////////////////////////////////////////
	// Variables for checking whether each process
	// (RequestLeft, RequestRight, HonorRequest, DirtyChops) is possible to execute.
	bool okL, okR, okD, okH, x;
	do
	:: 
		okL = 0; okR = 0; okD = 0; okH = 0;
		for(i : 0 .. NUM_SMITH - 1 ){
            x = 0 ;
            LeftOk(i, x);
            okL = okL || x;

            x = 0;
            RightOk(i, x);
            okR = okR || x;

            x = 0;
            DirtyOk(i, x);
            okD = okD || x;

            x = 0;
            RequestOk(i, x);
            okH = okH || x ;
        }
		if
		::	okL -> RequestLeft();
		::  okR -> RequestRight();
		::  okD -> DirtyChops();
		::  okH -> HonorRequest(); 
		fi;
	od;
}

ltl non_starvation{
	//	Fill in the property.

	true // Dummy variable
}