# Instrument

Draft instrument, created in response to the Round 1 data circa May 2021.


## LTL -> Eng

- Q. a0 -> X(X(a0))
  A. if a0 is initially true, then it is also true after two steps
  m0. (miss ->) a0 holds initially
  m1. (implicit G) if a0 holds then holds every other step
  m2. (span X) if a0 initially then a0 holds for next 2 steps
  m3. (span and X implies converse in current step) impossible, asks for a0 and !a0 at first step
  src. Class

- Q. X(X(F(X(a0))))
  A. a0 true after 3 or more steps
  m0. (not commute) after 2 steps, eventually state where a0 true next
  m1. (drop inner) after 2 steps a0 eventually true
  m2. (mix inner outer) after 1 step a0 eventually true
  m3. (drop F) a0 true in 3 steps
  src. Instructor / Authors

- Q. F(a0) -> G(a1)
  A. if a0 eventually then a1 for all time
  m0. (scope F) eventually a0 implies a1 evermore
  m1. (-> is step) if a0 eventually then a1 starting at next step
  m2. (ignore ->) a0 eventually holds, and a1 always holds when a0 does
  src. Instructor

- Q. (a0 U a1) and G(a0)
  A. always a0 and eventually a1 too
  m0. (weak U) always a0
  m1. (rhs U negates lhs) impossible
  src. Authors

- Q. G(a0 -> ( X(!a0) and X(X(a0)) ))
  A. whenever a0 is true, it becomes false in the next state and true again in the state after that
  m0. (drop XX) impossible
  m1. (span XX) impossible
  m2. (miss ->) a0 always off/on
  src. Instructor


## Eng -> LTL

- Q. whenever a0 is true, it becomes false in the next state and true again in the state after that
  A. G(a0 => ( X(!a0) and X(X(a0)) ))
  m0. (commute !X) a0 => ( !X(a0) and X(X(a0)) )
   BOGUS
  m0. (missing G) a0 => ( X(!a0) and X(X(a0)) )
  m2. (miss ->) G(a0 => X(!a0)) and G(!a0 => X(a0))
  m3. (U for ->) G(x1 U X(!x1) and X(X(x1)))
  src. Instructor

- Q. a0 is true in exactly one state, but not necessarily the first state
  A. !a0 U (a0 and X(G(!a0)))
     == F(a0) and G(a0 => X(G(!a0)))
  m0. (-> guarantees premise) G(a0 -> G(X(!a0)))
  m1. (cannot count) impossible
  m2. (implicit G, nested) !a0 U (a0 and X(!a0))
  m3. (once F) F(a0)
  m4. (mix G F) !a0 U (a0 and X(F(!a0)))
  src. Class + Authors (not necessarily)

- Q. a0 cannot be true three states in a row
  A. G(!(a0 and X(a0) and X(X(a0)))) == !F(a0 and X(a0) and X(X(a0)))
  m0. (implicit G) !(a0 and X(a0) and X(X(a0)))
  m1. (swap -> for and) G(!(a0 -> X(a0) -> X(X(a0))))
  m2. (span X) G(!X(X(X(a0))))
  src. Class

- Q. whenever a0 is true, a1 will be true at some point in the future
  A. G(a0 -> F(a1))
  m0. (extra X) G(a0 -> X(F(a1)))
  m1. (missing G) a0 -> F(a1)
  src. Instructor

- Q. a0 is true for a finite number of steps, and then never again becomes true
  A. a0 U G(!a0)
  m0. (implicit G in U rhs) a0 U !a0
  m1. (U negates) a0 U true
  m2. (-> for U) a0 and (a0 -> G(!a0))
  m3. (-> lhs always eventually sat) a0 -> F(G(!a0))
  m4. (only try X) impossible 
  src. Authors / Class (x1 starts true, and then never again becomes true)


