
- ImplicitG : assume that a formula (or subformula) constrains all future states
    - Expected `G(a0)` but student wrote `a0`

- UnspecInert : assume that properties do not change unless specified; more precisely, assume a propositional value for the current state and assume that the valuation cannot change without permission from a formula term
    - Expected `a0 U (!a0 and a1)` but student wrote `a0 U a1`
    - Expected `F(a0) and G(a0 => XG(!a0))` but student wrote `F(a0 and X(!a0))`

- SansUntil : don't know that U exists / try to encode an "until" formula with F, G, and other operators

- WeakUntil : think that U has the weak-U behavior

- Precedence : make an incorrect assumption about operator precedence / use too few parenthesis

- Jump> : assumes that the left-hand side of an implication is eventually satisfied
    - Expected `F(a0) and G(a0 => a1)` but student wrote `G(a0 => a1)`

- CurrentState : write a correct term at the wrong time/state
    - Expected `a0 U (a1 and F(a2))` but student wrote `(a0 U a1) and F(a2)`
    - Expected `a0 and X(a1)` but student wrote `a0 and a1`

- BadMode : mis-use/swap a temporal operator (think: misunderstood the definition)
    - Expected `F(a0)` but student wrote `G(a0)`
    - Expected `a0 U a1` but student wrote `G(a0) U a1`
    - Expected `a0 => X(a1)` but student wrote `X(a0, a1)` or rather `a0 X a1`

- BadProp : mis-use/swap a logical operator (think: misunderstood the definition)
    - Expected `a0 => a1` but student wrote `a0 and a1`


- Miscomm : mis-interpret the English prompt / provide a good answer to a different question
The answer gets at the wrong question. The student mis-interpreted the English prompt.

- Typo : make a simple typo --- either with temporal operators (mis-counting X), logical operators (forgot a "not"), or English (swap "Red" with "Blue")

