- BadProp : mis-use/swap a logical operator (think: misunderstood the definition) or atom
    - Expected `a0 => a1` but learner wrote `a0 and a1`
    - Expected `a0 => a1` but learner wrote `a0 => a0`

- BadStateIndex : write a correct term at the wrong time/state index
    - Expected `a0 U (a1 and F(a2))` but learner wrote `(a0 U a1) and F(a2)`
    - Expected `a0 and X(a1)` but learner wrote `a0 and a1`
    - Expected `X(a0)` but learner wrote `XX(a0)`

- BadStateQuantification : mis-use/swap a temporal operator (think: misunderstood the definition)
    - Expected `F(a0)` but learner wrote `G(a0)`
    - Expected `a0 U a1` but learner wrote `G(a0) U a1`
    - Expected `a0 => X(a1)` but learner wrote `X(a0, a1)` or rather `a0 X a1`

- ImplicitF : assume that a formula (or subformula) happens at some point, now or in the future
    - Expected `F(a0)` but learner wrote `a0`
    - Expected `F(a0) and G(a0 => a1)` but learner wrote `G(a0 => a1)`

- ImplicitG : assume that a formula (or subformula) constrains all future states
    - Expected `G(a0)` but learner wrote `a0`

- Precedence : make an incorrect assumption about operator precedence / use too few parenthesis

- SansUntil : don't know that U exists / try to encode an "until" formula with F, G, and other operators

- UnspecInert : assume that properties do not change unless specified; more precisely, assume a propositional value for the current state and assume that the valuation cannot change without permission from a formula term
    - Expected `!a0 U a0` but learner wrote `F(a0)`
    - Expected `F(a0) and G(a0 => XG(!a0))` but learner wrote `F(a0 and X(!a0))`

- WeakUntil : think that U has the weak-U behavior


- Miscomm : META-TAG, use for valid mis-interpretations of the question

