// Implementation of a single flag protocol to solve the
// producer-consumer problem.

bool flag = 0;

active proctype Producer() {
  tryagain:
    flag == 0; // Wait for consumer to finish reading
    // Write to the buffer now
    flag = 1; // Tell consumer there's new data
  goto tryagain;
}

active proctype Consumer () {
  tryagain:
    flag == 1; // Wait for producer to finish writing
    // Read from the buffer now
    flag = 0; // Tell producer it can write again
  goto tryagain;
}


