// Proving producer-consumer and non-starvation

bool flag = 0;
bool in_cs[2];
bool data = 0;

active proctype Producer() {
  tryagain:
    flag == 0;
      in_cs[_pid] = 1; 
      assert(data == 0); // there isn’t unread data
      data = 1; // data has been written
      in_cs[_pid] = 0; 
    flag = 1; 
  goto tryagain;
}

active proctype Consumer () {
  tryagain:
    flag == 1;
    in_cs[_pid] = 1;
    assert(in_cs[1 - _pid] == 0);
    assert(data == 1); // there is unread data
    data = 0; // data now read
    in_cs[_pid] = 0;
    flag = 0;
  goto tryagain;
}

ltl eager_no_starvation { always in_cs[1] }

