
- Stx : The answer is not valid Electrum syntax.
- Past : The answer contains a past-time operator (once, before, historically, ')

- Assoc : The answer contains a badly-placed pair of parenthesis. If these parens were moved, the formula would be better.
- ImplicitPar : The answer is missing an important pair of parentheses.
- AndThen (subset of ImplicitPar) : The answer is missing an important pair of parentheses around the body of an `after`.
    - Perhaps the student thinks that logical `and` binds tighter than `after`.

- Jump> : The answer assumes that the left-hand side of an implication is eventually satisfied.
    - Expected `F(a0) and G(a0 => a1)` but student wrote `G(a0 => a1)`

- StrongF : The answer uses a mere `eventually` when extra constraints are required.
    - Expected `a0 U G(!a0)` but student wrote `F(a0 and X(G(!a0)))`

- WeakU : The answer suggests that `until` is weak, and does not require its left-hand side to become true eventually.

- NegU : The answer suggests that the left-hand side of an `until` must be false when the right-hand side is true.
    - Expected `a0 U (!a0 and a1)` but student wrote `a0 U a1`

- ImplicitG : The answer is missing an `always` operator.
    - Expected `G(a0)` but student wrote `a0`
- ImplicitG_Ur (subset of ImplicitG) : The answer is missing an `always` on the right-hand side of an `until`
    - Expected `a0 U G(a1)` but student wrote `a0 U a1`

- ImplicitF : The answer is missing an `eventually` operator.
    - Expected `a0 and F(a1)` but student wrote `a0 and a1`

- ExtraG : The answer has an additional `always` operator.
    - Expected `a0 U a1` but student wrote `G(a0 U a1)`
- ExtraG_Ul (subset of ExtraG) : The answer has an additional `always` operator on the left-hand side of an `until`
    - Expected `a0 U a1` but student wrote `(G(a0)) U a1`

- SwapFG : The answer swaps an `eventually` to an `always`
    - Expected `F(a0)` but student wrote `G(a0)`
- SwapGF : The answer swaps an `always` to an `eventually`
- SwapU> : The answer swaps an `until` to an implication
- Swap>U : The answer swaps an implication to an `until`
- Swap^> : The answer swaps a conjunction to an implication

- XCount : The answer is nearly correct, but with too many or too few `after` operators.
- XSpan : The answer suggests that an `after` holds for more than one state.
    - Expected `X(a0) and X(X(a0))` but student wrote `X(X(a0))`
- XNeg : The answer suggests that an `after` holds when its condition is false in the current state and true in the next state.
    - Expected `!a0 and X(a0)` but student wrote `X(a0)`

- Q6_BadLasso : The student believes that traces lasso on some state other than the final (5th) state.
- Q6_NoLasso : The student believes that traces do not lasso, but rather stop at the final state.

