#### L -> E

- Q27 - Red implies after ( after ( after ( Red ) ) )
  ImplicitG + Xspan (robot/FM) when the red light is on, it keeps being red for the following 3 next states
  ImplicitG (ai) Red is on for 0 or more states; the 3rd state (next-next-next state) after each state where red is on will have red be on.
  ImplicitG (fm) If the red light is on in a given state, the red light will be on again in the third following state
  ImplicitG (ai) If Red is on at some timestep, then it must be on at 3 timesteps after that timestep.

- Q28 - after ( after ( eventually ( after ( Red ) ) ) )
  MisX (fm) ignoring the first two states, the panel shows red at some point
  MisX (ai) red is on in some state after the first two states

- Q29 - { eventually ( Red ) } implies { always ( Blue ) }
  BSI (ai) Red is on at some point, after which blue is always on

- Q30 - ( ( Red ) until ( Blue ) ) and always ( Red )
  ? ImplicitG (ai) The red light is always on and there is always a future state where the blue light will turn on (since it is strong 'until').
  UntilRHSOff (robot/fm) The statement can be never satisfied.
  WeakUntil (fm/other=pl/se) Red is always on.
  WeakUntil (ai) Red must always be on. (I am not sure which flavor of "until" that is. If it's the kind that insists that the part after the "until" happens, then I'd add "and Blue must eventually switch on.")
  ? BSQ (fm) The Red light is always on. The Blue light is on in the second state.

- Q31 - always ( Red implies ( after ( not Red ) and after ( after ( Red ) ) ) )
  OI (fm) Red continuously toggles between on and off at each state transitions.


#### E -> L

- Q37 - Whenever the Red light is on, it is off in the next state and on again in the state after that.
  ImplicitG (robot/ai) Red implies ( ( after not Red ) and ( after after Red) )
  ??? (ai) (eventually (red)) implies (after (not red and (after (red)))

- Q38 - The Red light is on in exactly one state, but not necessarily the first state.
  FSeq (ai/fm) F (a & X G!a)
  FSeq (ai) eventually (Red and after (always (not Red)))
  ImplicitG (fm) Eventually (Red) and (Red implies after (always not Red))
  BSI (ai/fm) (not Red) U (Red and (G(not red)))
  FSeq (fm) Eventually (Red & After (Always (! Red)))
  ImplicitG (fm) (eventually Red) and (Red implies (after(always (not Red))))

- Q39 - The Red light cannot stay on for three states in a row.
  BadProp (robot/fm) always not (red implies (after red and after after red))
  ImplicitG + RV (ai) Red implies (after(not red) or after(after(not red)) or after(after(after(not red))))

- Q40 - Whenever the Red light is on, the Blue light will be on then or at some point in the future.
  ImplicitG (robot/ai) Red implies ( eventually Blue )
  ImplicitG (robot/ai) Red implies ( eventually Blue )

- Q41 - The Red light is on for zero or more states, and then turns off and remains off in the future.
  BSI BadProp (robot/ai) Red implies( after(Red) or (always not( Red) ) )
  ImplicitG (fm) Red until ( not Red ) and ( not Red implies after not Red )  
  OtherImplicit (fm) eventually (not Red and always not Red)
  BSQ (ai) Red until (eventually(always(not red)))

