;; data = listof q-info
;; q-info = (or/c simple-q trace-q)
;; simple-q = (list q-num formula-or-english answer)
;; trace-q = (list q-num formula trace true?)
;; true? = boolean?
;; everything else = string?

(
("Q11"
"Red"
"{GB} {RGB} {RGB} {RGB} {RGB}"
#false)

("Q13"
"always { Red implies after { after { after { Red } } } }"
"{} {RGB} {RGB} {} {RGB}"
#true)

("Q14"
"after { Red } until after { Green }"
"{RB} {RB} {RB} {RGB} {B}"
#true)

("Q15"
"eventually { Red } and eventually { Green }"
"{} {G} {} {} {R}"
#true)

("Q16"
"after { after { eventually { Red } } }"
"{RGB} {RGB} {RGB} {RGB} {RGB}"
#true)

("Q17"
"Red until Blue"
"{R} {R} {R} {R} {R}"
#false)

("Q18"
"eventually { always { Red } }"
"{} {RGB} {} {RGB} {}"
#false)

("Q19"
"always { Red implies Green }"
"{} {} {} {} {}"
#true)


("Q27"
"Red implies after { after { after { Red } } }"
"if Red is initially lit, then it is also lit after three steps")

("Q28"
"after { after { eventually { after { Red } } } }"
"Red is lit after 3 or more steps")

("Q29"
"eventually { Red } implies always { Blue }"
"if Red is eventually lit then Blue is always lit")

("Q30"
"{ Red until Blue } and always { Red }"
"Blue is eventually lit and Red is always lit")

("Q31"
"always { Red implies { after { not Red } and after { after { Red } } } }"
"whenever Red is lit, it turns off in the next state and on again in the state after that")


("Q37"
"Whenever the Red light is on, it turns off in the next state and on again in the state after that."
("always { Red implies { after { not Red } and after { after { Red } } } }"
"always { Red in Panel.lit implies { after { not Red in Panel.lit } and after { after { Red in Panel.lit } } } }"
))

("Q38"
"The Red light is on in exactly one state, but not necessarily the first state."
("{ not Red } until { Red and after { always { not Red } } }"
"{ Red not in Panel.lit } until { Red in Panel.lit and after { always { Red not in Panel.lit } } }"
"{ Red not in Panel.lit } until { Red in Panel.lit and after { always { not Red in Panel.lit } } }"
"{ not Red in Panel.lit } until { Red in Panel.lit and after { always { not Red in Panel.lit } } }"
"eventually { Red in Panel.lit } and always { Red in Panel.lit implies after { always { Red not in Panel.lit }}}"
"eventually { Red in Panel.lit } and always { Red in Panel.lit implies after { always { not Red in Panel.lit }}}"
"eventually { Red in Panel.lit } and always { Red in Panel.lit implies always { after { not Red in Panel.lit }}}"
"eventually { Red in Panel.lit } and always { Red in Panel.lit implies always { after { Red not in Panel.lit }}}"
))

("Q39"
"The Red light cannot stay lit for three states in a row."
("not eventually { Red and after { Red } and after { after { Red } }}"
"always { Red in Panel.lit and after { Red in Panel.lit } implies after { after { Red not in Panel.lit }}}"
"always { Red in Panel.lit and after { Red in Panel.lit } implies after { after { not Red in Panel.lit }}}"
"always { not { Red in Panel.lit and after { Red in Panel.lit } and after { after { Red in Panel.lit }}}}"
))

("Q40"
"Whenever the Red light is on, the Blue light will turn on at some point."
("always { Red implies eventually { Blue }}"
))

("Q41"
"The Red light is lit for a finite number of steps, and then never again becomes lit."
("{ Red } until always { not Red }"
"{Red in Panel.lit} until always { not Red in Panel.lit }"
"always {Red in Panel.lit or {always {Red not in Panel.lit implies after Red not in Panel.lit}}} and not {always Red in Panel.lit}"
"eventually { Red not in Panel.lit } and always { Red not in Panel.lit implies always { Red not in Panel.lit } }"
))

)
